# Spec D2 AFScore
D2 computes the inner product of the kmer count vectors.

Extends | AFScore
All Extended | AFScore
Defined in | <seqan/alignment_free.h>
Signature | `template <> struct AFScore<D2>;`

## Member Function Overview

- `AFScore::AFScore(kmerSize, verbose);`
  Constructor

## Member Variable Overview

- `unsigned D2AFScore::kmerSize`
  Size of the kmers.
- `bool D2AFScore::verbose`
  `true` to enable verbose debug output.

## Detailed Description

To be used for alignment free comparison.

### References

Lippert RA, et al. Distributional regimes for the number of k-word matches between two random sequences. Proc. Natl Acad. Sci. USA 2002.

## See Also

- alignmentFreeComparison

## Member Functions Detail

### `AFScore::AFScore(kmerSize, verbose);`

Constructor

#### Parameters

`verbose` | This option will report progress to standard output (`bool</tt).`
`kmerSize` | Size of kmer (`unsigned`).

#### Data Races

Thread safety unknown!

#### See Also

- alignmentFreeComparison

## Member Variables Detail

### `unsigned D2AFScore::kmerSize`

Size of the kmers.

### `bool D2AFScore::verbose`

`true` to enable verbose debug output.

#### Dox Sources

    /*!
     * @class D2AFScore D2 AFScore
     *
     * @extends AFScore
     *
     * @headerfile <seqan/alignment_free.h>
     *
     * @brief D2 computes the inner product of the kmer count vectors.
     *
     * @signature template <> struct AFScore<D2>;
     *
     * To be used for alignment free comparison.
     *
     * @section References
     *
     * Lippert RA, et al. Distributional regimes for the number of k-word matches
     * between two random sequences. Proc. Natl Acad. Sci. USA 2002.
     *
     * @see alignmentFreeComparison
     *
     * @fn D2AFScore::AFScore
     *
     * @brief Constructor
     *
     * @signature AFScore::AFScore(kmerSize, verbose);
     *
     * @param[in] verbose This option will report progress to standard output
     *                    (<tt>bool</tt).
     * @param[in] kmerSize Size of kmer (<tt>unsigned</tt>).
     *
     * @see alignmentFreeComparison
     *
     * @var unsigned D2AFScore::kmerSize;
     *
     * @brief Size of the kmers.
     *
     * @var bool D2AFScore::verbose;
     *
     * @brief <tt>true</tt> to enable verbose debug output.
     */